package io.zipcoder;

import org.junit.Assert;
import org.junit.Test;

public class ParenCheckerTest {

@Test

    public void testCheckBalancedParentheses() {
    //given
   String input= "{[]('<>')}";
   boolean expectedOutput= true;

    //when
    boolean actualOutput =ParenChecker.checkBalancedParentheses(input);

    //then
    Assert.assertEquals(expectedOutput, actualOutput);

}


    @Test

    public void testCheckBalancedParentheses1() {
        //given
        String input= "{[](>)}])";
        boolean expectedOutput= false;

        //when
        boolean actualOutput =ParenChecker.checkBalancedParentheses(input);

        //then
        Assert.assertEquals(expectedOutput, actualOutput);

    }

    @Test

    public void testCheckBalancedParentheses2() {
        //given
        String input= "he{[l]l(o s)i[mr]an}";
        boolean expectedOutput= true;

        //when
        boolean actualOutput =ParenChecker.checkBalancedParentheses(input);

        //then
        Assert.assertEquals(expectedOutput, actualOutput);

    }

    @Test

    public void testCheckBalancedParentheses3() {
        //given
        String input= "h[el{lo }si>mra<n";
        boolean expectedOutput= false;

        //when
        boolean actualOutput =ParenChecker.checkBalancedParentheses(input);

        //then
        Assert.assertEquals(expectedOutput, actualOutput);

    }
}